require 'active_model'

module GreekFire
  class Metric < Struct.new(:name, :labels, :value)
    include ActiveModel::Conversion

    @registry = []
    @dynamic_measures ||= []
    class << self
      def register(measurer=nil, &block)
        @registry << measurer unless measurer.nil?

        @dynamic_measures << block if block_given?
      end

      def metrics
        (@dynamic_measures.map do |stat|
          stat.call
        end + @registry).flatten.compact
      end

      def clear_metrics
        @registry.clear
        @dynamic_measures.clear
      end
    end
  end
end
