module GreekFire
  class SmartLabel < HashWithIndifferentAccess
    attr_reader :value

    def initialize(value, key_pairs)
      super(key_pairs)
      @value = value
    end

    def update(other_hash)
      super(other_hash)
      @value = other_hash.value if other_hash.is_a? SmartLabel
      self
    end

    def dup
      self.class.new(value, self).tap do |new_hash|
        set_defaults(new_hash)
      end
    end
  end
end